// Blooming-effect


uniform sampler2D sourceTexture;
uniform float     dx;
uniform float     dy;
uniform float     filterKernel[5];
uniform int       renderPass;


vec4 doBlur( vec2 coords[5] )
{
	// do the look-ups
	vec4 col[5];
	col[0] = texture2D( sourceTexture, coords[0] );
	col[1] = texture2D( sourceTexture, coords[1] );
	col[2] = texture2D( sourceTexture, coords[2] );
	col[3] = texture2D( sourceTexture, coords[3] );
	col[4] = texture2D( sourceTexture, coords[4] );

	vec4 color = vec4( 0.0, 0.0, 0.0, 1.0 );	
	color += col[0] * filterKernel[0];
	color += col[1] * filterKernel[1];
	color += col[2] * filterKernel[2];
	color += col[3] * filterKernel[3];
	color += col[4] * filterKernel[4];

	// return filtered value
	return color;
}


/*
 *  blur texture horizontal
 */
vec4 blurHorizontal()
{
	// calculate coords for lookup
	vec2 coords[5];
	coords[0] = gl_TexCoord[1].st;
	coords[1] = gl_TexCoord[1].st + vec2( dx, 0.0 );
	coords[2] = gl_TexCoord[1].st - vec2( dx, 0.0 );
	coords[3] = gl_TexCoord[1].st + vec2( 2.0 * dx, 0.0 );
	coords[4] = gl_TexCoord[1].st - vec2( 2.0 * dx, 0.0 );
	
	return doBlur( coords );
/*
	// do the look-ups
	vec4 col[5];
	col[0] = texture2D( sourceTexture, coords[0] );
	col[1] = texture2D( sourceTexture, coords[1] );
	col[2] = texture2D( sourceTexture, coords[2] );
	col[3] = texture2D( sourceTexture, coords[3] );
	col[4] = texture2D( sourceTexture, coords[4] );

	vec4 color = vec4( 0.0, 0.0, 0.0, 1.0 );	
	color += col[0] * filterKernel[0];
	color += col[1] * filterKernel[1];
	color += col[2] * filterKernel[2];
	color += col[3] * filterKernel[3];
	color += col[4] * filterKernel[4];

	// return filtered value
	return color;
*/
}


/*
 *  blur texture vertical
 */
vec4 blurVertical()
{
	// calculate coords for lookup
	vec2 coords[5];
	coords[0] = gl_TexCoord[1].st;
	coords[1] = gl_TexCoord[1].st + vec2( 0.0, dy );
	coords[2] = gl_TexCoord[1].st - vec2( 0.0, dy );
	coords[3] = gl_TexCoord[1].st + vec2( 0.0, 2.0 * dy );
	coords[4] = gl_TexCoord[1].st - vec2( 0.0, 2.0 * dy );
	
	return doBlur( coords );
}




void main()
{
	vec4 fragColor = vec4( 0.0, 0.0, 0.0, 1.0 );

	if ( renderPass == 0 ) {
		// blur horizontal
		fragColor = blurHorizontal();
	} else {
		// blur vertical
		fragColor = blurVertical();
	}

	gl_FragColor = fragColor;

    // just pass image to screen
    //gl_FragColor = texture2D( texture, gl_TexCoord[1].st);
}
