uniform sampler2D sceneTexture;
uniform sampler2D bloomTexture;
uniform float     glowFactor;


void main()
{
	vec4 sceneCol = texture2D( sceneTexture, gl_TexCoord[1].st );
	vec4 bloomCol = texture2D( bloomTexture, gl_TexCoord[1].st );

	if ( bloomCol.rgb != vec3( 0.0, 0.0, 0.0 ) ) {
		// blooming area
		gl_FragColor = sceneCol + bloomCol * glowFactor;
		//gl_FragColor = vec4( 0.0, 1.0, 0.0, 1.0 );
	} else {
		// non-blooming area
		gl_FragColor = sceneCol;
		//gl_FragColor = vec4( 1.0, 0.0, 0.0, 1.0 );
	}

    // just pass image to screen
    //gl_FragColor = texture2D( texture, gl_TexCoord[1].st );
}
