
uniform mat4 shadowMatrix, posLightMatrix;
uniform vec4 lightPositionView;

varying vec3 normal, lightVector, halfVector;
varying vec4 shadowCoord, posLight;


void main()
{
    gl_TexCoord[0] = gl_MultiTexCoord0;
    gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;

	// --- lighting ---    
    vec4 viewVector = normalize( -( gl_ModelViewMatrix * gl_Vertex )); // vertex in view-space => view-vector

    normal      = normalize( gl_NormalMatrix * gl_Normal      );  // normal to view-space
    lightVector = normalize( lightPositionView.xyz );
    halfVector  = normalize( lightVector.xyz + viewVector.xyz );
	// ---
	
    // --- SHADOWs ---
    shadowCoord = shadowMatrix   * gl_Vertex;
    posLight    = posLightMatrix * gl_Vertex;
}
